!= Module Radiation
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: radiation.f90,v 1.14 2011-03-30 13:53:08 sugiyama Exp $
! Tag Name::  $Name: arare4-20120911 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
!ǥͲ׻뤿Υѥå⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * 
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module Radiation
  !
  !ǥͲ׻뤿Υѥå⥸塼
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * 
  !

  !⥸塼ɤ߹
  use dc_message, only: MessageNotify
  use debugset,   only: cpurank
  use GridSet,  only: DimXMin,     & !x β
    &                 DimXMax,     & !x ξ
    &                 DimZMin,     & !z β
    &                 DimZMax,     & !z ξ
    &                 RegZMin,     & !x β
    &                 RegXMax,     & !x ξ
    &                 RegXMin,     & !z β
    &                 RegZMax,     & !z ξ
    &                 DelZ,        & !ʻҴֳ
    &                 s_Z            !Z ɸ(顼ʻ)
  use TimeSet,  only: DayTime        ! 1 Ĺ [s]
!  use basicset, only: xz_ExnerBasicZ !ʡؿδܾ
  use basicset, only: xz_ExnerBasicZ, & !ʡؿδܾ
    &                 xz_PressBasicZ, & !Ϥδܾ
    &                 xz_PotTempBasicZ, & !̤δܾ
    &                 PressSfc,       & !ɽ̰
    &                 CpDry,          & !갵Ǯ
    &                 CvDry,          & !Ǯ
    &                 GasRDry,        & !
    &                 Grav              !ϲ®
  use StorePotTemp,  only: StorePotTempRad, StorePotTempDamp
  
  !ۤηػ
  implicit none

  !private °
  private

  !ؿ public ˤ. 
  public Radiation_init
  public xz_RadHeatConst
  public xz_RadHeatVary
  public xz_NewtonCool
  public xz_radheatbalance

  !ѿ
  real(8), save              :: RadHeatRate = 0.0d0  !ͲǮΨ [K/day]
  real(8), save              :: RadCoolRate = 0.0d0  !ͲǮΨ [K/day]
  real(8), save, allocatable :: xz_RadHeight(:,:)    !ͲǮ¸ߤΰ
  real(8), save, allocatable :: xz_RadHeight2(:,:)   !ͲǮ¸ߤΰ
  real(8), save              :: RadHeight1 = 0.0d0
  real(8), save              :: RadHeight2 = 0.0d0
  integer, save              :: IntHeightUp = 0.0d0  !Ǯ¤αľɸб
  integer, save              :: IntHeightUp2 = 0.0d0 !Ѱ¤αľɸб

contains

!!!------------------------------------------------------------------------!!!
  subroutine Radiation_init(cfgfile)
    !
    !NAMELIST Ͷ
    !

    !ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile
    real(8)                  :: RadHeightUp   = 0.0d0  !ͶͿľΰξ
    real(8)                  :: RadHeightDown = 0.0d0  !ͶͿľΰβ
    real(8)                  :: RadHeightUp2  = 0.0d0  !ͶͿľΰξ
    real(8)                  :: RadHeightDown2= 0.0d0  !ͶͿľΰβ
    integer                  :: k                      !롼ѿ

    ! NAMELIST 
    NAMELIST /radiation/ RadHeatRate, RadHeightUp, RadHeightDown, &
      & RadCoolRate, RadHeight1, RadHeight2, RadHeightUp2, RadHeightDown2

    open (10, FILE=cfgfile)
    read(10, NML=radiation)
    close(10)

    ! IntHeightUp 
    do k = DimZMin, DimZMax
      if ( (RadHeightUp - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp) ) then
        IntHeightUp = k
      else if ( (RadHeightUp2 - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp2) ) then
        IntHeightUp2 = k
      end if
    end do

    allocate( xz_RadHeight(DimXMin:DimXMax, DimZMin:DimZMax) )
    allocate( xz_RadHeight2(DimXMin:DimXMax, DimZMin:DimZMax) )

    ! Ͷ¸ߤΰ
    ! RadHeightDown < s_Z < RadHeightUp ϰϤǤͤ 1 Ȥʤ
    ! Ѱդ.
    !
    xz_RadHeight  = 1.0d0 
    xz_RadHeight2 = 1.0d0 

    do k = DimZMin, DimZMax
      if ( s_Z(k) <= RadHeightDown  ) then
        xz_RadHeight(:,k) = 0.0d0 
      elseif( s_Z(k) >= RadHeightUp ) then
        xz_RadHeight(:,k) = 0.0d0 
      end if
    end do

    do k = DimZMin, DimZMax
      if ( s_Z(k) <= RadHeightDown2  ) then
        xz_RadHeight2(:,k) = 0.0d0 
      elseif( s_Z(k) >= RadHeightUp2 ) then
        xz_RadHeight2(:,k) = 0.0d0 
      end if
    end do

    if (cpurank == 0) then 
      call MessageNotify( "M", &
        & "Radiation", "RadHeatRate = %f", d=(/RadHeatRate/))
      call MessageNotify( "M", &
        & "Radiation", "RadHeightUp = %f", d=(/RadHeightUP/))
      call MessageNotify( "M", &
        & "Radiation", "RadHeightDown= %f", d=(/RadHeightDown/))
    end if
  end subroutine Radiation_init


!!!------------------------------------------------------------------------!!!
  function xz_RadHeatConst(xz_Exner)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !ʡؿξ
    real(8)               :: xz_RadHeatConst(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !Ͷ

    xz_RadHeatConst = &
      & xz_RadHeight * RadHeatRate  &
      & / ( ( xz_ExnerBasicZ + xz_Exner ) * DayTime )

    call StorePotTempRad( xz_RadHeatConst )
    
  end function xz_RadHeatConst
  
  
!!!------------------------------------------------------------------------!!!
  function xz_RadHeatVary(xz_Exner)
  !
  ! ̤Ͷ.
  ! ɽ̤ RadHeight1 ǻꤵ줿٤ޤǤδ֤2[K/day](RadHeatRate)
  ! ͤѤͿ.
  ! RadHeight1  RadHeight2 ޤǤ (RadHeight2 - s_Z(k)) / (RadHeight2 - RadHeight1)
  ! γѤθ̤򸺾 (RadHeight2Ǥ礦ɥˤ)
  ! Nakajima and Matsuno(1988),(1944)򻲹ͤˤ
  !

  !ۤηػ
  implicit none

  !ѿ
  real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !ʡؿξ
  real(8)               :: xz_RadHeatVary(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !Ͷ
  integer               :: k

  do k = RegZMin+1, DimZMax
   if (s_Z(k).le.RadHeight1) then
    xz_RadHeatVary(:,k) = &
      & RadHeatRate  &
      & / ( ( xz_ExnerBasicZ(:,k) + xz_Exner(:,k) ) * DayTime )

   else if (s_Z(k).gt.RadHeight1.and.s_Z(k).le.RadHeight2) then
    xz_RadHeatVary(:,k) = &
      & RadHeatRate  * (RadHeight2 - s_Z(k)) &
      & / ( (RadHeight2 - RadHeight1) * ( xz_ExnerBasicZ(:,k) + xz_Exner(:,k) ) * DayTime )

   else if (s_Z(k).gt.RadHeight2) then
    xz_RadHeatVary(:,k) = 0.0d0

   end if
  end do

  call StorePotTempRad( xz_RadHeatVary )

end function xz_RadHeatVary

!!!------------------------------------------------------------------------!!!
  function xz_NewtonCool(xz_PotTemp)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !̤ξ
    real(8)               :: xz_NewtonCool(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !Ͷ
    real(8)               :: xz_PotTempMean(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !̾ʿ
    real(8)               :: EFTime    !ʹ»
    integer               :: k

    !ʹ»֤ 5 
    EFTime = 5.0d0 * DayTime  
    
    do k = DimZMin, DimZMax
      xz_PotTempMean(:,k) = sum( xz_PotTemp(:,k) ) / real(DimXMax - DimXMin + 1)
    end do
    
    xz_NewtonCool = - xz_PotTempMean / EFTime 
    
    call StorePotTempDamp( xz_NewtonCool )

  end function xz_NewtonCool


!!!------------------------------------------------------------------------!!!
  function xz_RadHeatBalance(xz_ExnerBasicZ, xz_PotTempBasicZ, xz_Exner, xz_PotTemp)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǶŪ˰ͤʲǮ, 
    ! RadHeight  RadHeight2 ޤǤδ֤ǶŪʰͤѤͿ. 
    ! ͶΤȤƲǮѤХ󥹤褦˻ͲǮΨ
    ! ӰΨѲ. 
    ! ѤοͿ, ǮοĴ᤹. 

    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)   :: xz_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)               :: xz_RadHeatBalance(DimXMin:DimXMax, DimZMin:DimZMax)
                                        !Ͷ
    real(8)               :: xz_DensSum(DimXMin:DimXMax, DimZMin:DimZMax) 
                                        !̩(ܾʬȾʬ)
    real(8)               :: HeatSum    !Ǥñ̻βǮ
    real(8)               :: CoolSum    !Ǥñ̻
    integer               :: i
    integer               :: k

    ! ̩٤λ
    xz_DensSum = PressSfc &
      & * (xz_ExnerBasicZ + xz_Exner)**( CvDry /GasRDry ) &
      & / (GasRDry * (xz_PotTempBasicZ + xz_PotTemp ) )

    HeatSum = 0.0d0
    CoolSum = 0.0d0

    !ǮΤ,  0 - 1000 m => ʻ 1 (RegZMin + 1)  IntHeightUp
    !ѤΤ,  1000 - 15000 m => ʻ IntHeightUp + 1  IntHeightUp2
    !*** ȴ *** 
    ! IntHeightUp 
    !do k = DimZMin, DimZMax
    !  if ( (RadHeightUp - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp) ) then
    !    IntHeightUp = k
    !  else if ( (RadHeightUp2 - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp2) ) then
    !    IntHeightUp2 = k
    !  end if
    !end do
    !
    ! ü                           1000 
    !   |--*--|--*--|--*--|--*--|--*--|--*--|--*--|
    !      1                       5  
    !
    !  1000                                      Max
    !   |--*--|--*--|--*--|--*--|--*--|--*--|--*--|
    !      6                                   I

    ! Ǥ (Ǯ/ǮΨ) ׻
    do k = RegZmin + 1, IntHeightUp 
       do i = RegXmin + 1, RegXMax
          HeatSum = HeatSum + DelZ * CpDry * xz_DensSum(i,k)
       end do
    end do

    ! Ǥ (/Ψ) ׻
    do k = IntHeightUp + 1, IntHeightUp2 
       do i = RegXmin + 1, RegXMax
          CoolSum = CoolSum + DelZ * CpDry * xz_DensSum(i,k)
       end do
    end do

    ! ǮΨλ
    ! RadCoolRate ͤǤ뤳Ȥ. 
    RadHeatRate = - RadCoolRate * CoolSum / HeatSum

    xz_RadHeatBalance = &
      & xz_RadHeight * RadHeatRate  &
      & / ( xz_ExnerBasicZ  * DayTime ) &
      & + xz_RadHeight2 * RadCoolRate  &
      & / ( xz_ExnerBasicZ  * DayTime )

    call StorePotTempRad( xz_RadHeatBalance )
    
  end function xz_RadHeatBalance
  
end module Radiation
